/**
 * @file
 * Provides Splide extensions for onwheel event.
 */

(function (_db, _ds) {

  'use strict';

  var Wheel = function (Splide, Components) {
    var o = Splide.options;
    var zoomOn = o.zoom && o.zoom.on;

    return {
      mount: function () {
        var me = this;

        if (o.wheel && !zoomOn) {
          _db.bindEvent(Splide.root, 'wheel', me.slide.bind(me), {
            passive: false
          });
        }
      },

      /**
       * Slides to prev or next onwheel.
       *
       * @param {EventObject} e
       *   The wheel event object.
       */
      slide: function (e) {
        e.preventDefault();

        var delta = _ds.wheelDelta(e);
        Splide.go(delta > 0 ? '+' : '-');
      }

    };
  };

  _ds.extend({
    Wheel: Wheel
  });

})(dBlazy, dSplide);
